# A Python script to demostrate the output of the 'Ycon' utility.
# Run it from a Terminal with 'python testycon.py'.
# (Ycon must be in your path, of course.)

# When it runs, a 'Ycon' window should appear at top left; drag any
# icon, or other droppable object onto the window, and it will print out
# the raw received string, and a List structure containing the contents
# of the drop-message in processable form.
# (Or you can copy something to the clipboard and paste it into the window.)


import os

# function to accumulate all the lines from a message into a single string
def getmsg():
	mstr = ""
	s = 1
	while s != "":	# empty string returned when Ycon is closed
	    s = pp.readline()	# one message produces multiple lines of text
	    mstr = mstr+s
	    if s == "]\n":	# but the final one always looks like this
	        break
	return mstr

pp = os.popen("Ycon -d")	# start Ycon and read from it via pipe
# (Note that the '-d' option means that long binary items will get printed
# in their entirety.  If you would prefer short form, remove the option.)

str = 1		# start with an arbitrary non-string
while str != "":	# loops until Ycon is terminated
	str = getmsg()
	print "received string:\n", str
	# convert entire string to a list object:
	sobj = repr(str)	# this should take care of embedded newlines in strings
 	print "converted list:\n", eval(sobj)

